# demo_2: __add__
class Ratio:
	def __init__(self, n, d):
		self.numer = n
		self.denom = d

	def __repr__(self):
		return 'Ratio({0}, {1})'.format(self.numer, self.denom)

	def __str__(self):
		return '{0}/{1}'.format(self.numer, self.denom)
# (1)
# >>> Ratio(1,3) + Ratio(1,6)
# Error

	#(2)
	def __add__(self, other):
        	# (3) type dispatching: inspect the type of the argument to select the behavior
		if isinstance(other, int):
			n = self.numer + self.denom * other
			d = self.denom
        	# (5) type coercion: convert one value to match the type of the another
		elif isinstance(other, float):
			return float(self) + other
		elif isinstance(other, Ratio):
			 # (2)
			n = self.numer * other.denom + self.denom * other.numer
			d = self.denom * other.denom
		g = gcd(n, d)
		return Ratio(n//g, d//g)
    
    # (4) a+b: a.__add__(b), b.__radd__(a)
	__radd__ = __add__
	
    # (5)
	def __float__(self):
        	return self.numer/self.denom
    
# (2)
def gcd(n, d):
	while n != d:
		n, d = min(n, d), abs(n-d)
	return n

# (2)
# >>> Ratio(1,3) + Ratio(1,6)
# Ratio(1,2)
# >>> Ratio(1,3) + 1
# Error 'int' object has no denom
# Then we need __add__ of version (3)

# (3)
# >>> Ratio(1,3) + Ratio(1,6)
# Ratio(1,2)
# >>> Ratio(1,3) + 1
# Ratio(4,3)
# >>> 1 + Ratio(1,3)
# Error need define __radd__ in class Ratio

# (4)
# >>> 1 + Ratio(1,3)
# Ratio(4,3)

# (5)
# >>> Ratio(1,2) + 1.2
# 1.7

